;
; squelette programme tray
;

;
; Directives de l'assembleur
;
.686P												;; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX													;; pour activer les instructions mmx
.XMM													;; pour activer les instructions sse,sse2
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED											;; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP											;; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE										;; optionel: rends les identifiants sensibles  la casse de caractres


;
; Fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
;INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \MAsm32\INCLUDE\masm32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
;INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \MAsm32\LIB\masm32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; Prototypes
;
GestionnaireMessagesBoiteDialoguePrincipale	PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoitesDialogue			PROTO :DWORD,:DWORD,:DWORD,:DWORD
;FusionnerMultiplesChainesAscii			PROTO C :DWORD,:VARARG	; ici, on utilise VARARG, aussi il faut utiliser la convention C


.CONST
;
; Constantes
;
Nombre_De_Resolutions_Maximal		equ 128
WM_SHELLNOTIFY					equ WM_USER + 1
IDI_TrayIcone					equ 500					;; id de l'icne pour le groupe d'icnes tray

; identifiants des ressources
Rsrc_IDI_Icone_16				equ 516

Rsrc_IDM_Separateur				equ 999

Rsrc_IDM_Resolutions			equ 1001					;; id de dpart pour les lignes du menu
Rsrc_IDM_Quitter_G				equ 1498
Rsrc_IDM_Annuler_G				equ 1499

Rsrc_IDM_Menu_Droit				equ 1500
Rsrc_IDM_Menu_Droit_C			equ 1501
Rsrc_IDM_Option_1				equ 1511
Rsrc_IDM_Option_2				equ 1512
Rsrc_IDM_Option_3				equ 1513

Rsrc_IDM_Quitter_D				equ 1998
Rsrc_IDM_Annuler_D				equ 1999

Rsrc_IDD_Insuffisant			equ 2100
Rsrc_IDC_Insuffisant_C			equ 2101
Rsrc_IDC_Desole				equ 2102
Rsrc_IDC_Temps_Changer			equ 2103

Rsrc_IDD_Quitter				equ 2200
Rsrc_IDC_Quitter_C				equ 2201
Rsrc_IDC_Vraiment_quitter		equ 2202
Rsrc_IDC_Hum_Oui				equ 2203
Rsrc_IDC_Ah_Ca_Non				equ 2204


.DATA
;
; Definition des STRUCTURES
;

; structure pour la cration/la suppression d'une instance mmoire
_Memoire_Informations_ STRUCT								;; pour un total de 16 octets
	_Instance_			DWORD ?						;; (align 16) pointeur de l'instance
	_Taille_Initiale_		DWORD ?						;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?						;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?						;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Memoire_Informations_ ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_ STRUCT									;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?						;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?						;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?						;; (align 8) pointeur de la zone utilisable (align sur 16 octets)
	_Taille_Reelle_Du_Bloc_	DWORD ?						;; la taille relle, peut tre utilis pour allouer une zone mmoire additionnelle de marge
_Bloc_Memoire_ ENDS

; structure pour l'allocation/la libration d'un bloc mmoire spcifique aux crans
_Bloc_Memoire_Ecran_ STRUCT								;; pour un total de 64 octets
	_Largeur_Ecran_X4_		DWORD ?						;; (align 16) largeur de l'cran relle multiplie par 4 (*DWORD) (ajout, parceque souvent utilis, evite donc des shl,2)
	_Largeur_Ecran_		DWORD ?						;; largeur de l'cran (en pixels)
	_Hauteur_Ecran_		DWORD ?						;; (align 8) hauteur de l'cran (en pixels)
	_Taille_Reelle_Du_Bloc_	DWORD ?						;; la taille relle, peut tre utilis pour allouer une zone mmoire additionnelle de marge
	_Taille_Du_Bloc_		DWORD ?						;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_inutilise_01_			DWORD ?						;; inutilis...
	_Pointeur_			DWORD ?						;; (align 8) pointeur de la zone utilisable (adresse aligne sur 16 octets)
	_Pointeur_A_Liberer_	DWORD ?						;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_LimitesFace_	DWORD ?						;; (align 16) pointeur de la zone limites face (zro quand ce n'est pas un cran double)
	_Pointeur_Dbuffer_		DWORD ?						;; pointeur de la zone Dbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Pointeur_Zbuffer_		DWORD ?						;; (align 8) pointeur de la zone Zbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Temoins_Ecran_		DWORD ?						;; tmoins de l'cran... bit 0=cran double buffet utilis
_Bloc_Memoire_Ecran_ ENDS


.DATA
;
; variables
;

ALIGN 16
Instance_Application	DWORD ?
Instance_Boite_Dialogue	DWORD ?
Pointeur_Ligne_Commande	DWORD ?
Pointeur_Fenetre		DWORD ?
Pointeur_DC_Ecran		DWORD ?
Pointeur_Menu_Gauche	DWORD ?
Pointeur_Menu_Droit		DWORD ?
Pointeur_Temporaire		DWORD ?

;Numero_Affichage_Selectionne	DWORD ?
Nombre_Affichages			DWORD ?
Resolutions_Trouvees		DWORD 1
Temoin_Menu				DWORD 0
Temoin_Resolutions			DWORD 00100000b
; bit 5 = 32 bits
; bit 4 = 16 bits / 24 bits
; bit 3 = 8 bits (256 couleurs)
; bit 2 = 4 bits (16 couleurs)
; bit 1 =
; bit 0 =


Chaine_Information_Application	BYTE "Permet de changer la rsolution cran",0
Chaine_Titre_Fenetre			BYTE "Programme",0
Chaine_Type_Fenetre				BYTE "Type Personnalis",0

;Chaine_Largeur				BYTE " "
Chaine_Valeur_Largeur		BYTE "            ",0
Chaine_Hauteur				BYTE "*"
Chaine_Valeur_Hauteur		BYTE "            ",0
Chaine_Bits				BYTE "*"
Chaine_Valeur_Bits			BYTE "            ",0
Chaine_Frequence			BYTE " a "
Chaine_Valeur_Frequence		BYTE "            ",0
Chaine_Fin_De_Chaine		BYTE " Mhz",0

Chaine_Nom_Device			BYTE MAX_PATH dup (0)
Chaine_Copyright			BYTE "NightWare ",0
Chaine_Quitter				BYTE "Quitter l'application",0 
Chaine_Annuler				BYTE "Annuler",0

Tampon_Resolutions			DWORD Nombre_De_Resolutions_Maximal*5 DUP (0)


ALIGN 16
; variables structures
Position_Pointeur_Ecran			POINT <?>
Resolution_Ecran				DEVMODE <>
Informations_Menu				MENUITEMINFO <?>
Informations_Messages_OS			MSG <?>					;; 5 Dwords + 2 Words
Informations_Fenetre			WNDCLASSEX <?>				;; 12 Dwords
Notification_Donnees_Icone		NOTIFYICONDATA <?>


.CODE
;
; les Macros
;


.CODE
;
; les procdures gnriques utilises
;
INCLUDE GenericProcs.asm


.CODE
;
; les procdures spcifiquement cres pour le programme
;


ALIGN 16
;
;
;
DefinirMenuResolutions PROC
		pushad

; redfinir le menu ?
		cmp Temoin_Menu,1								;; un menu  dja t dfini ?
		jne EviterSupprimerMenu							;; si ce n'est pas le cas, aller EviterSupprimerMenu
; sinon, supprimer les lignes existantes (devenues inutiles) pour dfinir un nouveau menu...
		invoke DestroyMenu,Pointeur_Menu_Gauche				;; supprimer le menu gauche
; nettoyer les rsolutions dj trouves
		mov eax,Nombre_De_Resolutions_Maximal*5*DWORD
		mov edi,OFFSET Tampon_Resolutions
		call EffacerBlocMemoire

EviterSupprimerMenu:

		invoke CreatePopupMenu							;; crer un menu popup
		mov Pointeur_Menu_Gauche,eax						;; sauvegarder le pointeur obtenu

; prremplir la structure MENUITEMINFO
		mov Informations_Menu.cbSize,SIZEOF MENUITEMINFO		;; placer la taille de la structure
		mov Informations_Menu.fMask,MIIM_STATE or MIIM_ID or MIIM_TYPE	;; masques  utiliser pour les lignes du menu
		mov Informations_Menu.fType,MFT_STRING				;; spcifier que ce sont des chanes
		mov Informations_Menu.fState,MFS_ENABLED			;; ce sera des lignes normales
		mov Informations_Menu.hSubMenu,0					;; ce menu n'en appelera pas d'autres
; numerer les affichages disponibles
		mov Nombre_Affichages,0
		mov ebx,Rsrc_IDM_Resolutions+1
BoucleNombreAffichages:
;		mov Resolution_Ecran.dmBitsPerPel,0
		invoke EnumDisplaySettings,NULL,Nombre_Affichages,ADDR Resolution_Ecran
		cmp eax,FALSE									;; pas une rsolution valide ?
		je FinBoucleNombreAffichages						;; si c'est le cas, aller FinBoucleNombreAffichages
;
		mov eax,Resolution_Ecran.dmBitsPerPel
		and eax,Temoin_Resolutions
		jz EviterInsertion
; cette rsolution est dj dfinie ?
		mov ecx,1
		mov esi,OFFSET Tampon_Resolutions
		mov edi,0
		mov Resolutions_Trouvees,ecx
		sub esi,5*DWORD
BoucleRechercheResolutionExistante:
		add esi,5*DWORD
		mov edx,0
		mov eax,Resolution_Ecran.dmBitsPerPel
		cmp eax,DWORD PTR [esi]
		jne Dword01Ok
		inc edx
Dword01Ok:
		mov eax,Resolution_Ecran.dmPelsWidth
		cmp eax,DWORD PTR [esi+1*DWORD]
		jne Dword02Ok
		inc edx
Dword02Ok:
		mov eax,Resolution_Ecran.dmPelsHeight
		cmp eax,DWORD PTR [esi+2*DWORD]
		jne Dword03Ok
		inc edx
Dword03Ok:
		mov eax,Resolution_Ecran.dmDisplayFlags
		cmp eax,DWORD PTR [esi+3*DWORD]
		jne Dword04Ok
		inc edx
Dword04Ok:
		mov eax,Resolution_Ecran.dmDisplayFrequency
		cmp eax,DWORD PTR [esi+4*DWORD]
		jne Dword05Ok
		inc edx
Dword05Ok:
		cmp edx,5
		je Semblable
		inc edi
Semblable:
		dec ecx
		jnz BoucleRechercheResolutionExistante
		cmp edi,Resolutions_Trouvees
		jne EviterInsertion
; sinon, dfinir une nouvelle rsolution dans le tampon temporaire
		inc Resolutions_Trouvees
		mov eax,Resolution_Ecran.dmBitsPerPel
		mov DWORD PTR [esi],eax
		mov eax,Resolution_Ecran.dmPelsWidth
		mov DWORD PTR [esi+1*DWORD],eax
		mov eax,Resolution_Ecran.dmPelsHeight
		mov DWORD PTR [esi+2*DWORD],eax
		mov eax,Resolution_Ecran.dmDisplayFlags
		mov DWORD PTR [esi+3*DWORD],eax
		mov eax,Resolution_Ecran.dmDisplayFrequency
		mov DWORD PTR [esi+4*DWORD],eax

; crer la chane a inserer dans le menu
		mov eax,Resolution_Ecran.dmBitsPerPel
		mov esi,OFFSET Chaine_Valeur_Bits
		call ConvertirValeurEnChaineDecimale
		mov eax,Resolution_Ecran.dmPelsWidth
		mov esi,OFFSET Chaine_Valeur_Largeur
		call ConvertirValeurEnChaineDecimale
		mov eax,Resolution_Ecran.dmPelsHeight
		mov esi,OFFSET Chaine_Valeur_Hauteur
		call ConvertirValeurEnChaineDecimale
		mov eax,Resolution_Ecran.dmDisplayFrequency
		mov esi,OFFSET Chaine_Valeur_Frequence
		call ConvertirValeurEnChaineDecimale

;		mov eax,5
;		mov edi,OFFSET Chaine_Nom_Device
;		mov BYTE PTR [edi],0
;		invoke FusionnerMultiplesChainesAscii,ADDR Chaine_Valeur_Largeur,ADDR Chaine_Hauteur,ADDR Chaine_Bits,ADDR Chaine_Frequence,ADDR Chaine_Fin_De_Chaine

		mov edi,OFFSET Chaine_Nom_Device
		mov BYTE PTR [edi],0
		invoke FusionnerMultiplesChainesAscii,5,ADDR Chaine_Valeur_Largeur,ADDR Chaine_Hauteur,ADDR Chaine_Bits,ADDR Chaine_Frequence,ADDR Chaine_Fin_De_Chaine
; insrer la chane
		mov eax,OFFSET Chaine_Nom_Device					;; placer l'adresse de la chaine  insrer dans eax
		mov Informations_Menu.dwTypeData,eax				;; et la recopier dans la structure MENUITEMINFO
		mov Informations_Menu.wID,ebx						;; placer l'id dans la structure MENUITEMINFO
		invoke InsertMenuItem,Pointeur_Menu_Gauche,ebx,FALSE,ADDR Informations_Menu	;; maintenant on peut crer la ligne du menu
EviterInsertion:
		inc Nombre_Affichages
		inc ebx
		jmp BoucleNombreAffichages
FinBoucleNombreAffichages:

; placer un sparateur
		mov Informations_Menu.fType,MFT_SEPARATOR			;; spcifier que c'est un sparateur
		mov Informations_Menu.wID,Rsrc_IDM_Separateur		;; placer l'id dans la structure MENUITEMINFO
		invoke InsertMenuItem,Pointeur_Menu_Gauche,Rsrc_IDM_Separateur,FALSE,ADDR Informations_Menu	;; maintenant on peut crer la ligne du menu
; placer les lignes suivantes
		mov Informations_Menu.fType,MFT_STRING				;; spcifier que ce sont  nouveau des chanes
		mov Informations_Menu.fState,MFS_ENABLED			;; et que ce sera  nouveau des lignes normales
; pour quitter
		mov eax,OFFSET Chaine_Quitter						;; placer l'adresse de la chaine  afficher dans eax
		mov Informations_Menu.dwTypeData,eax				;; et la recopier dans la structure MENUITEMINFO
		mov Informations_Menu.wID,Rsrc_IDM_Quitter_G			;; placer l'id dans la structure MENUITEMINFO
		invoke InsertMenuItem,Pointeur_Menu_Gauche,Rsrc_IDM_Quitter_G,FALSE,ADDR Informations_Menu	;; maintenant on peut crer la ligne du menu
; pour annuler
		mov eax,OFFSET Chaine_Annuler						;; placer l'adresse de la chaine  afficher dans eax
		mov Informations_Menu.dwTypeData,eax				;; et la recopier dans la structure MENUITEMINFO
		mov Informations_Menu.wID,Rsrc_IDM_Annuler_G			;; placer l'id dans la structure MENUITEMINFO
		invoke InsertMenuItem,Pointeur_Menu_Gauche,Rsrc_IDM_Annuler_G,FALSE,ADDR Informations_Menu	;; maintenant on peut crer la ligne du menu

		mov Temoin_Menu,1								;; le menu gauche est maintenant dfini

		popad
	ret
DefinirMenuResolutions endp


ALIGN 16
;
; ici,on inclus l'indispensable procdure de gestion des messages entre l'application et windows...
; elle traite les messages spcifiques,les autres sont retransmis au gestionnaire par defaut de windows.
; chaque message peut avoir une valeur additionnelle associe (situe dans les paramtres WParam et LParam).
; le rang de donnes additionnelle qui peuvent tre obtenues par l'application est dtermin par la nature du message.
;
; Rceptionne :
; rien (hormis les messages du systme d'exploitation,mais ca se fait automatiquement)
;
; Retourne:
; rien (mais attention eax est modifi)
;
GestionnaireMessagesBoiteDialoguePrincipale PROC HWndGMP:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM
;LOCAL DessinEcran :PAINTSTRUCT

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; les commandes (ici les lignes des menus gauche et droit qui sont cliques)
;
		cmp eax,WM_COMMAND								;; une ligne du menu est clique ?
		jne GMPPasCommande								;; si ce n'est pas le cas, aller GMPPasCommande
		mov eax,WParam									;; placer WParam dans eax (c'est plus rapide si le nombre d'id est consquent)

; une rsolution ?
		cmp eax,Rsrc_IDM_Resolutions						;; comparer l'id  l'id de dpart des processus ?
		jb GMPasResolutions								;; si c'est infrieur, aller GMPasResolutions
		cmp eax,Rsrc_IDM_Resolutions+Nombre_De_Resolutions_Maximal	;; comparer l'id  l'id de dpart des processus, augmente du nombre de processus maximal ?
		ja GMPasResolutions								;; si c'est suprieur, aller GMPasResolutions

		sub eax,Rsrc_IDM_Resolutions+1						;; soustraire l'id de dpart
;		mov Numero_Affichage_Selectionne,eax									;; copier l'id dans ebx
; appliquer la rsolution slectionne
		invoke EnumDisplaySettings,NULL,eax,ADDR Resolution_Ecran
		invoke ChangeDisplaySettings,ADDR Resolution_Ecran,NULL

	ret												;; retourner (sortir de la procdure)
GMPasResolutions:

; quitter ?
		cmp eax,Rsrc_IDM_Quitter_G						;; quitter est cliqu ?
		jne GMPPasMenuGaucheClicQuitter					;; si ce n'est pas le cas, aller GMPPasMenuGaucheClicQuitter
		invoke DialogBoxParam,Instance_Boite_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
	ret												;; retourner (sortir de la procdure)
GMPPasMenuGaucheClicQuitter:

; annuler ?
		cmp eax,Rsrc_IDM_Annuler_G						;; annuler est cliqu ?
		jne GMPPasMenuGaucheClicAnnuler					;; si ce n'est pas le cas, aller GMPPasMenuGaucheClicAnnuler
; sinon,inutile de faire quoi que ce soit...
	ret												;; retourner (sortir de la procdure)
GMPPasMenuGaucheClicAnnuler:

; option 1 ?
		cmp eax,Rsrc_IDM_Option_1						;; option 1 est cliqu ?
		jne GMPPasMenuDroitClicOption1					;; si ce n'est pas le cas, aller GMPPasMenuDroitClicOption1
		btc Temoin_Resolutions,5							;; alterner le bit correspondant aux 32 bits
; mise  jour du menu concern
		jnc GMPSelection32								;; si c'est le cas, aller GMPSelection32
		invoke CheckMenuItem,Pointeur_Menu_Droit,Rsrc_IDM_Option_1,MF_UNCHECKED	;; enlever le marqueur
		jmp GMPPasSelection32							;; aller GMPPasSelection32
GMPSelection32:
		invoke CheckMenuItem,Pointeur_Menu_Droit,Rsrc_IDM_Option_1,MF_CHECKED	;; positionner le marqueur
GMPPasSelection32:
		call DefinirMenuResolutions
	ret												;; retourner (sortir de la procdure)
GMPPasMenuDroitClicOption1:

; option 2 ?
		cmp eax,Rsrc_IDM_Option_2						;; option 2 est cliqu ?
		jne GMPPasMenuDroitClicOption2					;; si ce n'est pas le cas, aller GMPPasMenuDroitClicOption2
		btc Temoin_Resolutions,4							;; alterner le bit correspondant aux 16 bits
; mise  jour du menu concern
		jnc GMPSelection16								;; si c'est le cas, aller GMPSelection16
		invoke CheckMenuItem,Pointeur_Menu_Droit,Rsrc_IDM_Option_2,MF_UNCHECKED	;; enlever le marqueur
		jmp GMPPasSelection16							;; aller GMPPasSelection8
GMPSelection16:
		invoke CheckMenuItem,Pointeur_Menu_Droit,Rsrc_IDM_Option_2,MF_CHECKED	;; positionner le marqueur
GMPPasSelection16:
		call DefinirMenuResolutions
	ret												;; retourner (sortir de la procdure)
GMPPasMenuDroitClicOption2:

; option 3 ?
		cmp eax,Rsrc_IDM_Option_3						;; option 3 est cliqu ?
		jne GMPPasMenuDroitClicOption3					;; si ce n'est pas le cas, aller GMPPasMenuDroitClicOption3
		btc Temoin_Resolutions,3							;; alterner le bit correspondant aux 8 bits
; mise  jour du menu concern
		jnc GMPSelection8								;; si c'est le cas, aller GMPSelection8
		invoke CheckMenuItem,Pointeur_Menu_Droit,Rsrc_IDM_Option_3,MF_UNCHECKED	;; enlever le marqueur
		jmp GMPPasSelection8							;; aller GMPPasSelection8
GMPSelection8:
		invoke CheckMenuItem,Pointeur_Menu_Droit,Rsrc_IDM_Option_3,MF_CHECKED	;; positionner le marqueur
GMPPasSelection8:
		call DefinirMenuResolutions
	ret												;; retourner (sortir de la procdure)
GMPPasMenuDroitClicOption3:

;; option 4 ?
;		cmp eax,Rsrc_IDM_Option_4						;; option 4 est cliqu ?
;		jne GMPPasMenuGaucheClicOption4					;; si ce n'est pas le cas, aller GMPPasMenuGaucheClicOption4
;
;	ret												;; retourner (sortir de la procdure)
;GMPPasMenuGaucheClicOption4:

; quitter ?
		cmp eax,Rsrc_IDM_Quitter_D						;; quitter est cliqu ?
		jne GMPPasMenuDroitClicQuitter					;; si ce n'est pas le cas, aller GMPPasMenuDroitClicQuitter
		invoke DialogBoxParam,Instance_Boite_Dialogue,Rsrc_IDD_Quitter,0,ADDR GestionnaireMessagesBoitesDialogue,0
	ret												;; retourner (sortir de la procdure)
GMPPasMenuDroitClicQuitter:

; annuler ?
		cmp eax,Rsrc_IDM_Annuler_D						;; annuler est cliqu ?
		jne GMPPasMenuDroitClicAnnuler					;; si ce n'est pas le cas, aller GMPPasMenuDroitClicAnnuler
; sinon,inutile de faire quoi que ce soit...
	ret												;; retourner (sortir de la procdure)
GMPPasMenuDroitClicAnnuler:


;
	ret												;; retourner (sortir de la procdure)
GMPPasCommande:


;
; les messages de notification
;
		cmp eax,WM_SHELLNOTIFY							;; un message de notification shell est reu ?
		jne GMPPasTrayIcon								;; si ce nest pas le cas, aller GMPPasTrayIcon

; clics sur l'icone tray ?
		cmp WParam,IDI_TrayIcone							;; c'est l'id de notre trayicon ?
		jne GMPPasTrayIcon								;; si ce nest pas le cas, aller GMPPasTrayIcon

;
; clic gauche ?
;
		cmp LParam,WM_LBUTTONDOWN						;; clic gauche ?
		jne GMPPasClicGauche							;; si ce n'est pas le cas, aller GMPPasClicGauche
;; sinon, positionner et afficher le menu
;		invoke GetCursorPos,ADDR Position_Pointeur_Ecran		;; obtenir la position du pointeur cran
;		invoke TrackPopupMenuEx,Pointeur_Menu_Gauche,TPM_CENTERALIGN or TPM_HORIZONTAL,Position_Pointeur_Ecran.x,Position_Pointeur_Ecran.y,HWndGMP,NULL

; positionner et afficher le menu
		invoke GetCursorPos,ADDR Position_Pointeur_Ecran		;; obtenir la position du pointeur cran
		invoke TrackPopupMenuEx,Pointeur_Menu_Gauche,TPM_CENTERALIGN or TPM_HORIZONTAL,Position_Pointeur_Ecran.x,Position_Pointeur_Ecran.y,HWndGMP,NULL

	ret												;; retourner (sortir de la procdure)
GMPPasClicGauche:

;
; clic droit ?
;
		cmp LParam,WM_RBUTTONDOWN						;; clic droit ?
		jne GMPPasClicDroit								;; si ce n'est pas le cas, aller GMPPasClicDroit
;; sinon, positionner et afficher le menu
;		invoke GetCursorPos,ADDR Position_Pointeur_Ecran		;; obtenir la position du pointeur cran
;		invoke TrackPopupMenuEx,Pointeur_Menu_Droit,TPM_CENTERALIGN or TPM_HORIZONTAL,Position_Pointeur_Ecran.x,Position_Pointeur_Ecran.y,HWndGMP,NULL

; positionner et afficher le menu
		invoke GetCursorPos,ADDR Position_Pointeur_Ecran		;; obtenir la position du pointeur cran
		invoke TrackPopupMenuEx,Pointeur_Menu_Droit,TPM_CENTERALIGN or TPM_HORIZONTAL,Position_Pointeur_Ecran.x,Position_Pointeur_Ecran.y,HWndGMP,NULL

	ret												;; retourner (sortir de la procdure)
GMPPasClicDroit:

;
	ret												;; retourner (sortir de la procdure)
GMPPasTrayIcon:


;
; fermeture de l'application ?
;
		cmp eax,WM_CLOSE								;; message de fermeture reu ?
		jne GMPPasFermeture								;; si ce n'est pas le cas, aller GMPPasFermeture
		jmp GMPSortir									;; sinon, idem WM_DESTROY
	ret												;; retourner
GMPPasFermeture:


;
; quitter l'application
;
		cmp eax,WM_DESTROY								;; le message de sortie est reu ?
		jne GMPPasQuitter								;; si ce n'est pas le cas, aller GMPPasQuitter
GMPSortir:
		invoke PostQuitMessage,WParam						;; envoyer le message de sortie
	ret												;; retourner (sortir de la procdure)
GMPPasQuitter:


;
; traitement par dfaut des messages de windows
;
		invoke DefWindowProc,HWndGMP,Message,WParam,LParam	;; traitement par dfaut
	ret												;; retourner (sortir de la procdure)
GestionnaireMessagesBoiteDialoguePrincipale ENDP


ALIGN 16
;
; gestionnaire des messages des boites de dialogue supplmentaires
;
GestionnaireMessagesBoitesDialogue PROC HWndGMBD:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message								;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

		cmp eax,WM_COMMAND								;; une commande ?
		jne GMBDFinCommandes							;; si ce n'est pas le cas, aller GMBDFinCommandes
		mov eax,WParam									;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,Rsrc_IDC_Temps_Changer					;; Il est temps d'en changer est cliqu ?
		jne GMBDPasTempsChangerMicro						;; si ce n'est pas le cas, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndGMBD,0						;; sinon,fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; et poster le message de sortie
	ret												;; retourner
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,Rsrc_IDC_Hum_Oui							;; Hum... oui est cliqu ?
		jne GMBDPasHumOui								;; si ce n'est pas le cas, aller GMBDPasHumOui
		invoke EndDialog,HWndGMBD,0						;; sinon,fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; poster le message de sortie
	ret												;; retourner
GMBDPasHumOui:

; Ah a non !
		cmp eax,Rsrc_IDC_Ah_Ca_Non						;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon								;; si ce n'est pas le cas, aller GMBDPasAhCaNon
		invoke EndDialog,HWndGMBD,0						;; sinon,fermer la boite de dialogue
	ret												;; retourner
GMBDPasAhCaNon:


;
	ret												;; retourner
GMBDFinCommandes:

;
; traitement par dfaut pour les boites de dialogue
;
		xor eax,eax									;; effacer eax (ce sera le traitement par dfaut des messages)
	ret												;; retourner
GestionnaireMessagesBoitesDialogue ENDP


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ALIGN 16
Programme:
;		invoke GetCurrentProcess							;; ) fixer la priorit de notre application  haute
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS		;; )
		invoke GetCommandLine							;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commande,eax					;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_Commande
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax						;; ) et sauvegarder le pointeur obtenu dans Instance_Application
		mov Informations_Fenetre.hInstance,eax				;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL						;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boite_Dialogue,eax					;;	) et sauvegarder le pointeur obtenu dans Instance_Boite_Dialogue

		invoke CreateMutex,NULL,TRUE,ADDR Chaine_Titre_Fenetre	;; ) test si l'application existe dj
		invoke GetLastError								;; )
		cmp eax,ERROR_ALREADY_EXISTS						;; )
		je ApplicationDejaExistante						;; )

;		invoke ShowCursor,FALSE							;; faire disparaitre le pointeur cran
;		mov esi,OFFSET Instance_Memoire					;; ) obtenir une instance mmoire
;		call CreerInstanceMemoire						;; )


;
; remplir la structure WNDCLASSEX avec les variables requises
;
		invoke LoadIcon,Instance_Application,Rsrc_IDI_Icone_16	;; pointeur sur l'icone (500 = ID de l'icne)
		mov Informations_Fenetre.hIcon,eax					;; sauver le pointeur
		invoke LoadCursor,NULL,IDC_ARROW
		mov Informations_Fenetre.hCursor,eax
; remplir le reste de la structure WNDCLASSEX avec les variables requises
		mov Informations_Fenetre.cbSize,SIZEOF WNDCLASSEX
		mov Informations_Fenetre.style,CS_BYTEALIGNCLIENT or CS_NOCLOSE
		mov Informations_Fenetre.lpfnWndProc,OFFSET GestionnaireMessagesBoiteDialoguePrincipale
		mov Informations_Fenetre.cbClsExtra,NULL
		mov Informations_Fenetre.cbWndExtra,NULL
		mov Informations_Fenetre.hbrBackground,COLOR_BACKGROUND
		mov Informations_Fenetre.lpszMenuName,NULL
		mov Informations_Fenetre.lpszClassName,OFFSET Chaine_Type_Fenetre
		mov Informations_Fenetre.hIconSm,0
		invoke RegisterClassEx,ADDR Informations_Fenetre
; maintenant que tous les parametres sont dfinis,on cr l'cran
		invoke CreateWindowEx,WS_EX_LEFT or WS_EX_TOOLWINDOW,ADDR Chaine_Type_Fenetre,ADDR Chaine_Titre_Fenetre,WS_POPUP,NULL,NULL,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,Instance_Application,NULL
		mov Pointeur_Fenetre,eax


;
; ici,on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call AptitudesDuProcesseur
; bit 0 = Cpuid support ?	) 1=oui, 0=non
; bit 1 = Fpu support ?		)
; bit 2 = Rdtsc support ?	)
; bit 3 = cMov support ?	)
; bit 4 = Mmx support ?		)
; bit 5 = Sse support ?		)
; bit 6 = Sse2 support ?	)
; bit 7 = Sse3 support ?	)
;		mov edx,000000000001b							;; cpuid
;		mov edx,000000000011b							;; cpuid + fpu
		mov edx,000000000111b							;; cpuid + fpu + rdtsc
;		mov edx,000000001111b							;; cpuid + fpu + rdtsc + cmov
;		mov edx,000000011111b							;; cpuid + fpu + rdtsc + cmov + mmx
;		mov edx,000000111111b							;; cpuid + fpu + rdtsc + cmov + mmx + sse
;		mov edx,000001111111b							;; cpuid + fpu + rdtsc + cmov + mmx + sse + sse2
;		mov edx,000011111111b							;; cpuid + fpu + rdtsc + cmov + mmx + sse + sse2 + sse3
		and eax,edx									;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx									;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant						;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
;		invoke ShowCursor,TRUE							;; faire rapparaitre le pointeur cran
		invoke MessageBeep,0FFFFFFFFh						;; 0FFFFFFFFh / MB_ICONASTERISK / MB_ICONEXCLAMATION / MB_ICONHAND / MB_ICONQUESTION / MB_OK
		invoke DialogBoxParam,Instance_Boite_Dialogue,Rsrc_IDD_Insuffisant,0,ADDR GestionnaireMessagesBoitesDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL	;; pour obtenir les messages provenants de toutes les applications
		cmp eax,NULL									;; comparer eax  zro
		je MicroprocesseurInsuffisant						;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS	;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS	;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessagesBoitesDialogue au moment voulu)
		jmp MicroprocesseurBoucleMessages					;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon,le minimum requis est prsent
;
		invoke GetDC,Pointeur_Fenetre						;; obtenir un device context relatif  la fentre
		mov Pointeur_DC_Ecran,eax						;; sauvegarder le pointeur obtenu


;
;  le menu gauche (que l'on dfinira tout de suite, puisque le hardware n'est pas sens changer en cours d'utilisation...)
;
		call DefinirMenuResolutions


;
; le menu droit
;
		invoke LoadMenu,Instance_Application,Rsrc_IDM_Menu_Droit	;; charger l'adresse de la resource menu
		invoke GetSubMenu,eax,0							;; obtenir le pointeur du premier (0) sous-menu (pour avoir un popup menu)
		mov Pointeur_Menu_Droit,eax						;; et sauver le pointeur obtenu dans Pointeur_Menu_Droit


;
; assigner l'icne au trays
;

; remplir la structure NOTIFYICONDATA (qui renseigne les informations ncessaire aux tray icons)
		mov Notification_Donnees_Icone.cbSize,SIZEOF NOTIFYICONDATA	;; placer la taille de la structure
		mov eax,Pointeur_Fenetre							;; ) sinon, recopier le pointeur fenetre dans la structure de notification
		mov Notification_Donnees_Icone.hwnd,eax				;; )
		mov Notification_Donnees_Icone.uID,IDI_TrayIcone		;; l'identifiant qui sera attribu  l'icne tray
		mov Notification_Donnees_Icone.uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP	;; les flags indiquant quelles autres donnes de la structure sont valides/utilises
		mov Notification_Donnees_Icone.uCallbackMessage,WM_SHELLNOTIFY	;; identifiant du message d'appel
		invoke LoadIcon,Instance_Application,Rsrc_IDI_Icone_16	;; ) placer le pointeur de l'icone
		mov Notification_Donnees_Icone.hIcon,eax			;; )
		mov esi,OFFSET	Chaine_Information_Application		;;	) recopier la chaine contenant l'information relative  l'application
		mov edi,OFFSET Notification_Donnees_Icone.szTip		;;	) (64 octets au maximum,zro final compris)
		call CopierChaineAscii							;;	)
; la structure tant remplie,on peut assigner l'icne aux tray icons
		invoke Shell_NotifyIcon,NIM_ADD,ADDR Notification_Donnees_Icone	;; assigner l'icne au trays


;
; on ne fait pas apparaitre la fentre... 
;
		invoke ShowWindow,Pointeur_Fenetre,SW_HIDE			;; SW_SHOWNORMAL or SW_SHOWMINNOACTIVE
		invoke UpdateWindow,Pointeur_Fenetre				;; mise  jour de la fentre


;
; boucle a effectuer tant que le message PostQuitMessage n'a pas t reu
;
BoucleMessages:
		invoke GetMessage,ADDR Informations_Messages_OS,NULL,NULL,NULL
		cmp eax,NULL
		je FinBoucleMessages
		invoke TranslateMessage,ADDR Informations_Messages_OS
		invoke DispatchMessage,ADDR Informations_Messages_OS
		jmp BoucleMessages
FinBoucleMessages:


;
; par ici la sortie...
;
		invoke Shell_NotifyIcon,NIM_DELETE,ADDR Notification_Donnees_Icone	;; supprimer l'icne des trays
		invoke DestroyMenu,Pointeur_Menu_Droit				;; supprimer le menu droit
		invoke DestroyMenu,Pointeur_Menu_Gauche				;; supprimer le menu gauche
		invoke DeleteDC,Pointeur_DC_Ecran					;; supprimer le device context
		invoke DestroyWindow,Pointeur_Fenetre				;; (pour supprimer les threads qui sont attachs  la fentre)
;		invoke Sleep,20								;; (pour s'assurer que tout aies le temps d'tre fait)
;		invoke ShowCursor,TRUE							;; faire rapparaitre le pointeur cran
MicroprocesseurInsuffisant:
;		mov esi,OFFSET Instance_Memoire					;; placer l'adresse de la structure instance mmoire dans esi
;		call SupprimerInstanceMemoire						;; ) supprimer l'intance mmoire
ApplicationDejaExistante:
;		invoke GetCurrentProcess							;;	) remettre la priorit du programme  la normale
;		invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS		;;	)
		invoke ExitProcess,Informations_Messages_OS.wParam	;; sortie de l'application
;
; fin du programme
;
END Programme

